#!c:/perl/bin/perl

# use strict;
use XML::Simple;
use Net::SNMP qw(:snmp);
use Mysql;
use File::Basename;

 require "c:/inetpub/wwwroot/cacti/aloe/include/aloeScriptFunctions.pl";
# require "c:/dev/aloe/include/aloeScriptFunctions.pl";


  $aloe_config_file = 'c:\\inetpub\\wwwroot\\cacti\\aloe\\config\\aloe-config.xml';
#  $aloe_config_file = 'c:\\dev\\aloe\\config\\aloe-config.xml';

  #
  # Load the configuration settings from aloe.xml.

  if (open (my $afh, "<", $aloe_config_file)) {

  	close($afh);
	$aloe  = XMLin($aloe_config_file);

  } else { die "Could not find $aloe_config_file, script can not continue"; }


  my $debug		= $aloe->{settings}->{debug}->{value};

  my $cactidbhost	= $aloe->{settings}->{cactiDBHost}->{value};
  my $cactidb		= $aloe->{settings}->{cactiDB}->{value};
  my $cactidbuser	= $aloe->{settings}->{cactiDBUser}->{value};
  my $cactidbpswd	= $aloe->{settings}->{cactiDBPswd}->{value};

  our $config_path      = $aloe->{settings}->{configPath}->{value};

  my $script_name	= basename($0);
  my $event_source      = "cacti -> $script_name";


  our $management_ip	= @ARGV[0];
  our $snmp_community	= @ARGV[1];
  our $snmp_version	= @ARGV[2];
  our $script_action	= @ARGV[3];
  our $index_value	= @ARGV[4];
  our $snmp_username	= '';
  our $snmp_password	= '';


  #
  # find the rrd file associated with this script instance

  initializeConfigFiles();


  initializeVariables();


	if ($script_action eq "index") { 

	  if (!loadGlobalCongfigTemplate()) { die "Could not find $config_template, script can not continue"; }

		indexQuery(

			$management_ip,
			$snmp_community,
			$snmp_username,
			$snmp_password,
			$snmp_version,

	); exit 0; }

	if ($script_action  eq "query") {

	  if (!loadGlobalCongfigTemplate()) { die "Could not find $config_template, script can not continue"; }

		queryQuery(

			$management_ip,
			$snmp_community,
			$snmp_username,
			$snmp_password,
			$snmp_version,
			$index_value

	); exit 0; }


inthealthMain();


sub initializeConfigFiles {

  #
  # find the rrd file associated with this script instance

  my $cdbh = Mysql->connect(undef, $cactidb, $cactidbuser, $cactidbpswd);
  my $cdbh = Mysql->connect($cactidbhost, $cactidb, $cactidbuser, $cactidbpswd);

  my $dbquery = join('',"select rrd_path from data_input_data_cache where command like '%$script_name", " ", $management_ip, " ", $snmp_community, " ", $snmp_version,  " ", $script_action, " ", $index_value, "';");

  my $csth = $cdbh->query($dbquery);
  my $cdbr = $csth->fetchrow();

  our $config_template          = join('', $config_path, "int-health-interface-template.xml");
  our $config_custom_template   = join('', $config_path, "/int-health-", $management_ip, ".xml" );
  our $config_specific_template = join('', $config_path, $management_ip, "/int-health-", $management_ip, ".", $index_value, ".xml" );
  our $graph_xml_file           = join('', $cdbr, ".xml" );

} # initializeConfigFiles


sub initializeVariables {

  our $snmpResult	= '';
  our $lastUpdate	= '';

  our $ifStdOids  	= '';
  our $ifCstmOids 	= '';

  our $event_ticket	= '';
  our $ticket_status    = '';
  our $ticket_number    = '';

  #
  # Declare variables to hold configuration values

  
  our	$ifSpeed 		= 0;
  our	$ifInOctets 		= 0;
  our	$ifOutOctets		= 0;
  our	$ifInUcastPkts 		= 0;
  our	$ifOutUcastPkts 	= 0;
  our	$ifInNUcastPkts 	= 0;
  our	$ifOutNUcastPkts	= 0;
  our	$ifInErrors 		= 0;
  our	$ifOutErrors 		= 0;
  our	$ifDescr 		= 0;
  our	$ifName 		= 0;
  our	$ifAlias 		= 0;
  our	$ifDuplex 		= 0;
  our	$ifDuplexDesc		= 0;
  our	$ifSCollisions 		= 0;
  our	$ifMCollisions 		= 0;
  our	$ifType 		= 0;
  our	$ifHwAddr 		= 0;
  our   $ifInDiscards		= 0;
  our   $ifOutDiscards		= 0;

  #
  # Declare variables to hold values from the last run

  our (
	$difInOctets,
	$difOutOctets,
	$difInUcastPkts,
	$difOutUcastPkts,
	$difInNUcastPkts,
	$difOutNUcastPkts,
	$difInErrors,
	$difOutErrors,
	$difSCollisions,
	$difMCollisions,
	$difSpeed,
	$difDuplex,
	$dlastUpdate
  );


  #
  # Declare variables to hold the calculated (cooked) values 

  our (
	$cooked_ifErrors,
	$cooked_ifInOctets,
	$cooked_ifOutOctets,
	$cooked_ifTotalPackets,
	$cooked_ifTotalOctets,
	$cooked_ifTotalCollisions,
	$cooked_ifInUtilization,
	$cooked_ifInUtilizationHealth,
	$cooked_ifOutUtilization,
	$cooked_ifOutUtilizationHealth,
	$cooked_ifErrorRate,
	$cooked_ifCollisionRate,
	$cooked_ifAccuracy,
	$cooked_ifAccuracyHealth,
	$cooked_ifDuplex,
	$cooked_ifSpeed,
	$cooked_ifHighwater,
	$cooked_time_delta,
	$cooked_lastUpdate
  );

} # initializeVariables


sub inthealthMain {


  if (!loadInterfaceConfig()) {

	print "Adding new interface\n";
	addNewInterface();
	outputToXMLFile();
	loadInterfaceConfig();
  }


#
# Avoid passing a non existant OID to snmpGet


  if (length($ifInOctets) > 1)      { push (@snmp_oid,$ifInOctets);        }
  if (length($ifOutOctets) > 1)     { push (@snmp_oid,$ifOutOctets);       }
  if (length($ifInUcastPkts) > 1)   { push (@snmp_oid,$ifInUcastPkts);     }
  if (length($ifOutUcastPkts) > 1)  { push (@snmp_oid,$ifOutUcastPkts);    }
  if (length($ifInNUcastPkts) > 1)  { push (@snmp_oid,$ifInNUcastPkts);    }
  if (length($ifOutNUcastPkts) > 1) { push (@snmp_oid,$ifOutNUcastPkts);   }
  if (length($ifInErrors) > 1)      { push (@snmp_oid,$ifInErrors);        }
  if (length($ifOutErrors) > 1)     { push (@snmp_oid,$ifOutErrors);       }
  if (length($ifSpeed) > 1)         { push (@snmp_oid,$ifSpeed);           }
  if (length($ifDescr) > 1)         { push (@snmp_oid,$ifDescr);           }
  if (length($ifName) > 1)          { push (@snmp_oid,$ifName);            }
  if (length($ifAlias) > 1)         { push (@snmp_oid,$ifAlias);           }
  if (length($ifDuplex) > 1)        { push (@snmp_oid,$ifDuplex);          }
  if (length($ifSCollisions) > 1)   { push (@snmp_oid,$ifSCollisions);     }
  if (length($ifMCollisions) > 1)   { push (@snmp_oid,$ifMCollisions);     }
  if (length($ifType) > 1)	    { push (@snmp_oid,$ifType);		   }
  if (length($ifHwAddr) > 1)	    { push (@snmp_oid,$ifHwAddr);	   }
  if (length($ifInDiscards) > 1)    { push (@snmp_oid,$ifInDiscards);	   }
  if (length($ifOutDiscards) > 1)   { push (@snmp_oid,$ifOutDiscards);	   }

   $snmpResult = snmpGet(

	$management_ip,
	$snmp_community,
	$snmp_username,
	$snmp_password,
	$snmp_version
	);

  $lastUpdate = time();
  $cooked_lastUpdate = localtime($lastUpdate);

  cookIfHealth();

  outputToXMLFile();

  outputToGraphXMLFile();

  if ($debug) { outputDebugInfo(); }

  outputToCacti();


exit(0);


} #inthealthMain


sub outputToCacti {

# Output to cacti

  printf ("ifInUtilization:%.3f ifOutUtilization:%.3f ifErrorRate:%.3f ifCollisionRate:%.3f",

	$cooked_ifInUtilization,
	$cooked_ifOutUtilization,
	$cooked_ifErrorRate,
	$cooked_ifCollisionRate

   );


} # outputToCacti


# sub outputToCacti {

# Output to cacti

#  printf ("ifInUtilization:%.3f ifOutUtilization:%.3f ifErrorRate:%.3f ifCollisionRate:%.3f ifInOctets:%s ifOutOctets:%s ifInErrors:%s ifCollisions:%s",

#	$cooked_ifInUtilization,
#	$cooked_ifOutUtilization,
#	$cooked_ifErrorRate,
#	$cooked_ifCollisionRate,
#	$snmpResult->{$ifInOctets},
#	$snmpResult->{$ifOutOctets},
#	$snmpResult->{$ifInErrors},
#	($snmpResult->{$ifSCollisions} + $snmpResult->{$ifMCollisions})

#   );


# } # outputToCacti

sub cookIfHealth {

#
# Calculate the interface health


		      	$cooked_ifSpeed     = ($snmpResult->{$ifSpeed} / 1000000);
			$cooked_time_delta  = ($lastUpdate - $dlastUpdate);
			$cooked_ifDuplex    = $ifDuplexDesc;
			
			if (!counterWrap($snmpResult->{$ifInErrors}, $difInErrors)) {
				$cooked_ifErrors = ($snmpResult->{$ifInErrors} - $difInErrors);

			} else { $cooked_ifErrors = nan; }

			if ((!counterWrap($snmpResult->{$ifInUcastPkts}, $difInUcastPkts)) && (!counterWrap($snmpResult->{$ifOutUcastPkts}, $difOutUcastPkts))) {
				$cooked_ifTotalPackets = (($snmpResult->{$ifInUcastPkts} - $difInUcastPkts) +
							  ($snmpResult->{$ifInNUcastPkts} - $difInNUcastPkts));

			} else { $cooked_ifTotalPackets = nan; }
				
			if ((!counterWrap($snmpResult->{$ifInOctets}, $difInOctets)) && (!counterWrap($snmpResult->{$ifOutOctets}, $difOutOctets))) {

				$cooked_ifTotalOctets  = (($snmpResult->{$ifInOctets}  - $difInOctets) +
							  ($snmpResult->{$ifOutOctets} - $difOutOctets));
				$cooked_ifInOctets     = ($snmpResult->{$ifInOctets}  - $difInOctets);
				$cooked_ifOutOctets    = ($snmpResult->{$ifOutOctets} - $difOutOctets);

			} else { $cooked_ifTotalOctets = nan; $cooked_ifInOctets = -1; $cooked_ifOutOctets = nan;}

			if ((!counterWrap($snmpResult->{$ifSCollisions}, $difSCollisions)) && (!counterWrap($snmpResult->{$ifMCollisions}, $difMCollisions))) {
				$cooked_ifTotalCollisions = (($snmpResult->{$ifSCollisions} - $difSCollisions) +
							     ($snmpResult->{$ifMCollisions} - $difMCollisions));

			} else { $cooked_ifTotalCollisions = nan; }

			if ($cooked_ifErrors >= 0 && $cooked_ifTotalPackets > 0) {
				$cooked_ifErrorRate  = (($cooked_ifErrors * 100) / $cooked_ifTotalPackets);
			 	$cooked_ifErrorRate      = sprintf("%.3f", $cooked_ifErrorRate);

				$cooked_ifAccuracy   = 100 - $cooked_ifErrorRate;

				if ($cooked_ifAccuracy = 100) { 
					$cooked_ifAccuracyHealth = "Good";

				} elsif
					(($cooked_ifAccuracy < 100) || ($cooked_ifAccuracy >= (100 - $threshold_ifError))) {
					$cooked_ifAccuracyHealth = "warning";
					$evt_message   = "$snmpResult->{$ifDescr} Interface accuracy dropped to $cooked_ifAccuracy percent";

					push (@threshold_vals,$cooked_ifAccuracyHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifAccuracyHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifAccuracyHealth);

					outputEventTicket();

				} elsif

					($cooked_ifAccuracy < (100 - $threshold_ifError)) {
					$cooked_ifAccuracyHealth = "err";
					$evt_message   = "$snmpResult->{$ifDescr} Interface accuracy dropped to $cooked_ifAccuracy percent";

					push (@threshold_vals,$cooked_ifAccuracyHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifAccuracyHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifAccuracyHealth);

					outputEventTicket();
				}

			} else { $cooked_ifErrorRate = 0; $cooked_ifAccuracy = 100; $cooked_ifAccuracyHealth = "Good";}

			if ($cooked_ifTotalCollisions >= 0 and $cooked_ifTotalPackets > 0) {
				$cooked_ifCollisionRate = ($cooked_ifTotalCollisions * 100) / $cooked_ifTotalPackets;
				$cooked_ifCollisionRate  = sprintf("%.3f", $cooked_ifCollisionRate);

			} else { $cooked_ifCollisionRate = 0; }


		if ($cooked_ifDuplex ne "Half") {
			

			if ($cooked_ifInOctets >= 0) {
				$cooked_ifInUtilization = (((($snmpResult->{$ifInOctets} - $difInOctets) * 8) * 100) / ($cooked_time_delta * $snmpResult->{$ifSpeed}));
				$cooked_ifInUtilization  = sprintf("%.3f", $cooked_ifInUtilization);

				if ($cooked_ifInUtilization <= ($threshold_ifUtilization)) { 
					$cooked_ifInUtilizationHealth = "Good";

				} elsif 

					($cooked_ifInUtilization >= ($threshold_ifUtilization) || $cooked_ifInUtilization >= ($threshold_ifUtilization)) {
					$cooked_ifInUtilizationHealth = "warning";
					$evt_message   = "$snmpResult->{$ifDescr} Interface input utilization now at $cooked_ifInUtilization percent";

					push (@threshold_vals,$cooked_ifInUtilizationHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifInUtilizationHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifInUtilizationHealth);

					outputEventTicket();

				} elsif 

					($cooked_ifInUtilization > ($threshold_ifUtilization + 5 )) { 
					$cooked_ifInUtilizationHealth = "err";
					$evt_message   = "$snmpResult->{$ifDescr} Interface input utilization now at $cooked_ifInUtilization percent";

					push (@threshold_vals,$cooked_ifInUtilizationHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifInUtilizationHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifInUtilizationHealth);

					outputEventTicket();
				}


			} else { $cooked_ifInUtilization = nan; $cooked_ifInUtilizationHealth = "err"; }


			if ($cooked_ifOutOctets >= 0) {
				$cooked_ifOutUtilization = (((($snmpResult->{$ifOutOctets} - $difOutOctets) * 8) * 100) / ($cooked_time_delta * $snmpResult->{$ifSpeed}));
				$cooked_ifOutUtilization  = sprintf("%.3f", $cooked_ifOutUtilization);


				if ($cooked_ifOutUtilization <= ($threshold_ifUtilization)) { 
					$cooked_ifOutUtilizationHealth = "Good";
				} elsif 

					($cooked_ifOutUtilization >= ($threshold_ifUtilization) || $cooked_ifOutUtilization >= ($threshold_ifUtilization + 5 )) {
					$cooked_ifOutUtilizationHealth = "warning";
					$evt_message   = "$snmpResult->{$ifDescr} Interface output utilization now at $cooked_ifOutUtilization percent";

					push (@threshold_vals,$cooked_ifOutUtilizationHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifOutUtilizationHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifOutUtilizationHealth);

					outputEventTicket();

				} elsif 

					($cooked_ifOutUtilization > ($threshold_ifUtilization + 5 )) { 
					$cooked_ifOutUtilizationHealth = "err";
					$evt_message   = "$snmpResult->{$ifDescr} Interface output utilization now at $cooked_ifOutUtilization percent";

					push (@threshold_vals,$cooked_ifOutUtilizationHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifOutUtilizationHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifOutUtilizationHealth);

					outputEventTicket();

				}


			} else { $cooked_ifOutUtilization = nan; $cooked_ifOutUtilizationHealth = "err"; }


		} # if not half duplex

		else { 


			if ($cooked_ifTotalOctets >= 0) {
				$cooked_ifInUtilization = ((($cooked_ifTotalOctets * 8) * 100) / ($cooked_time_delta * $snmpResult->{$ifSpeed}));
				$cooked_ifOutUtilization = 0;

				$cooked_ifInUtilization  = sprintf("%.3f", $cooked_ifInUtilization);
				$cooked_ifOutUtilization = sprintf("%.3f", $cooked_ifOutUtilization);


				if ($cooked_ifInUtilization <= ($threshold_ifUtilization)) { 
					$cooked_ifInUtilizationHealth = "Good";
					$cooked_ifOutUtilizationHealth = "Good";

				} elsif
					($cooked_ifInUtilization >= ($threshold_ifUtilization) || $cooked_ifInUtilization >= ($threshold_ifUtilization + 5 )) {
					$cooked_ifInUtilizationHealth = "warning";
					$cooked_ifOutUtilizationHealth = "warning";
					$evt_message   = "$snmpResult->{$ifDescr} Interface utilization now at $cooked_ifInUtilization percent";

					push (@threshold_vals,$cooked_ifInUtilizationHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifInUtilizationHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifInUtilizationHealth);

					outputEventTicket();

				} elsif

				 	($cooked_ifInUtilization > ($threshold_ifUtilization + 5 )) { 
					$cooked_ifInUtilizationHealth = "err";
					$cooked_ifOutUtilizationHealth = "err";

					$evt_message   = "$snmpResult->{$ifDescr} Interface utilization now at $cooked_ifInUtilization percent";

					push (@threshold_vals,$cooked_ifInUtilizationHealth);
					$threshold_violation = 1;

		  			($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $evt_message, $cooked_ifInUtilizationHealth);
					logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $cooked_ifInUtilizationHealth);

					outputEventTicket();
				}


			} else { $cooked_ifInUtilization = nan; $cooked_ifOutUtilization = nan; $cooked_ifInUtilizationHealth = "err"; $cooked_ifOutUtilizationHealth = "err";}


		} #  if half Duplex


	if (($aloe->{settings}->{aloeTicketMethod}->{value}) && (!$threshold_violation)) {
		 push (@threshold_vals,$cooked_ifAccuracyHealth);
		 push (@threshold_vals,$cooked_ifOutUtilizationHealth);
		 
		 my $event_priority = "notice";

		  ($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $management_ip, $index_value, $0, \@threshold_vals, $log_message, $event_priority);

			if ($ticket_status eq "Close") {
				 $evt_message = "$snmpResult->{$ifDescr} Monitored values back within threshold, closing ticket # $ticket_number.";
				 logEvent($aloe, $management_ip, $0, $ticket_status, $evt_message, $event_priority);
			}

	}

} # cookIfHealth


sub counterWrap($$) {

  # If the current counter value is greater than the previous than a counter wrap or reload hasn't occured, calculate the measurment.
  # Return's true if a counter wrap has occured.

  my $c = $_[0];
  my $d = $_[1];

  if ($c >= $d) {return 0;} else {return  1;}

} # counterWrap


sub getInterfaceDuplex {

	if (length($ifDuplex) > 1) { 

		push (@snmp_oid,$ifDuplex);

		   $snmpResult = snmpGet(

			$management_ip,
			$snmp_community,
			$snmp_username,
			$snmp_password,
			$snmp_version
			);

			$cooked_ifDuplex = "$ifCstmOids->{fields}->{ifDuplex}->{desc}->[$snmpResult->{$ifDuplex} ]";
#			if ($debug) { print "\n Duplex defined in standard if file, here is what i got $snmpResult->{$ifDuplex} \n"; }

	} else {

		$ifDuplex        = 0;
		$cooked_ifDuplex = "Full";


	} # if duplex


} # getInterfaceDuplex

sub loadGlobalCongfigTemplate {


  #
  # Check to see if the global config template exists.

  if (open (my $cfh, "<", $config_template)) {

  	close($cfh);
	$ifStdOids  = XMLin($config_template, ForceArray => ['value']);

	if (defined($ifStdOids->{fields}->{ifDuplex}->{oid}))		{ $ifDuplex	   = "$ifStdOids->{fields}->{ifDuplex}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifSCollisions}->{oid}))	{ $ifSCollisions   = "$ifStdOids->{fields}->{ifSCollisions}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifMCollisions}->{oid}))	{ $ifMCollisions   = "$ifStdOids->{fields}->{ifMCollisions}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifSpeed}->{oid}))		{ $ifSpeed	   = "$ifStdOids->{fields}->{ifSpeed}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifInOctets}->{oid}))		{ $ifInOctets	   = "$ifStdOids->{fields}->{ifInOctets}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifOutOctets}->{oid}))	{ $ifOutOctets	   = "$ifStdOids->{fields}->{ifOutOctets}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifInUcastPkts}->{oid}))	{ $ifInUcastPkts   = "$ifStdOids->{fields}->{ifInUcastPkts}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifOutUcastPkts}->{oid}))	{ $ifOutUcastPkts  = "$ifStdOids->{fields}->{ifOutUcastPkts}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifInNUcastPkts}->{oid}))	{ $ifInNUcastPkts  = "$ifStdOids->{fields}->{ifInNUcastPkts}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifOutNUcastPkts}->{oid}))	{ $ifOutNUcastPkts = "$ifStdOids->{fields}->{ifOutNUcastPkts}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifInErrors}->{oid}))		{ $ifInErrors	   = "$ifStdOids->{fields}->{ifInErrors}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifOutErrors}->{oid}))	{ $ifOutErrors	   = "$ifStdOids->{fields}->{ifOutErrors}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifDescr}->{oid}))		{ $ifDescr	   = "$ifStdOids->{fields}->{ifDescr}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifName}->{oid}))		{ $ifName	   = "$ifStdOids->{fields}->{ifName}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifAlias}->{oid}))		{ $ifAlias	   = "$ifStdOids->{fields}->{ifAlias}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifType}->{oid}))		{ $ifType	   = "$ifStdOids->{fields}->{ifType}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifHwAddr}->{oid}))		{ $ifHwAddr	   = "$ifStdOids->{fields}->{ifHwAddr}->{oid}.$index_value";		}
	if (defined($ifStdOids->{fields}->{ifInDiscards}->{oid}))	{ $ifInDiscards	   = "$ifStdOids->{fields}->{ifInDiscards}->{oid}.$index_value";	}
	if (defined($ifStdOids->{fields}->{ifInDiscards}->{oid}))	{ $ifOutDiscards   = "$ifStdOids->{fields}->{ifOutDiscards}->{oid}.$index_value";	}


	return 1; 

  } else { return 0; }



} # loadGlobalCongfigTemplate


sub addNewInterface($$) {

	if (!loadGlobalCongfigTemplate()) { die "Could not find $config_template, script can not continue"; }

	getInterfaceDuplex();

	loadDeviceConfigTemplate();

	getInterfaceDuplex();

	loadMonitorThresholds();

} # addNewInterface


sub loadDeviceConfigTemplate {

  #
  # Check to see if there is an xml file containing customized (non standard OID's) for this host, and
  # overide the global settings with them.


  my $host_config_dir = join('',$config_path,@ARGV[0]);

  if (!opendir (my $dfh, $host_config_dir)) {

	mkdir $host_config_dir;
	if ($debug) { print "directory $host_config_dir has been created\n" }
  }


  if (open (my $cfh, "<", $config_custom_template)) {

  	close($cfh);
	$ifCstmOids = XMLin($config_custom_template, ForceArray => ['value']);

	if (defined($ifCstmOids->{fields}->{ifDuplex}->{oid}))		{ $ifDuplex	   = "$ifCstmOids->{fields}->{ifDuplex}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifSCollisions}->{oid}))	{ $ifSCollisions   = "$ifCstmOids->{fields}->{ifSCollisions}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifMCollisions}->{oid}))	{ $ifMCollisions   = "$ifCstmOids->{fields}->{ifMCollisions}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifSpeed}->{oid}))		{ $ifSpeed	   = "$ifCstmOids->{fields}->{ifSpeed}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifInOctets}->{oid}))	{ $ifInOctets	   = "$ifCstmOids->{fields}->{ifInOctets}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifOutOctets}->{oid}))	{ $ifOutOctets	   = "$ifCstmOids->{fields}->{ifOutOctets}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifInUcastPkts}->{oid}))	{ $ifInUcastPkts   = "$ifCstmOids->{fields}->{ifInUcastPkts}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifOutUcastPkts}->{oid}))	{ $ifOutUcastPkts  = "$ifCstmOids->{fields}->{ifOutUcastPkts}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifInNUcastPkts}->{oid}))	{ $ifInNUcastPkts  = "$ifCstmOids->{fields}->{ifInNUcastPkts}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifOutNUcastPkts}->{oid}))	{ $ifOutNUcastPkts = "$ifCstmOids->{fields}->{ifOutNUcastPkts}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifInErrors}->{oid}))	{ $ifInErrors	   = "$ifCstmOids->{fields}->{ifInErrors}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifOutErrors}->{oid}))	{ $ifOutErrors	   = "$ifCstmOids->{fields}->{ifOutErrors}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifDescr}->{oid}))		{ $ifDescr	   = "$ifCstmOids->{fields}->{ifDescr}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifName}->{oid}))		{ $ifName	   = "$ifCstmOids->{fields}->{ifName}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifAlias}->{oid}))		{ $ifAlias	   = "$ifCstmOids->{fields}->{ifAlias}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifType}->{oid}))		{ $ifType	   = "$ifCstmOids->{fields}->{ifType}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifHwAddr}->{oid}))		{ $ifHwAddr	   = "$ifCstmOids->{fields}->{ifHwAddr}->{oid}.$index_value";		}
	if (defined($ifCstmOids->{fields}->{ifInDiscards}->{oid}))	{ $ifInDiscards	   = "$ifCstmOids->{fields}->{ifInDiscards}->{oid}.$index_value";	}
	if (defined($ifCstmOids->{fields}->{ifInDiscards}->{oid}))	{ $ifOutDiscards   = "$ifCstmOids->{fields}->{ifOutDiscards}->{oid}.$index_value";	}

  } # if device specific config file

} # loadDeviceConfigTemplate


sub loadMonitorThresholds {

  #
  # Load the threshold settings from config file
  # Get any default vales from the global template

  if (defined($ifStdOids->{thresholds}->{ifUtilization}->{$cooked_ifDuplex}))	{ $threshold_ifUtilization   = "$ifStdOids->{thresholds}->{ifUtilization}->{$cooked_ifDuplex}";	}
  if (defined($ifStdOids->{thresholds}->{ifAccuracy}->{setting}))		{ $threshold_ifError         = "$ifStdOids->{thresholds}->{ifAccuracy}->{setting}";	}

  # Override them with any values from the custom device template.

  if (defined($ifCstmOids->{thresholds}->{ifUtilization}->{$cooked_ifDuplex}))	{ $threshold_ifUtilization   = "$ifCstmOids->{thresholds}->{ifUtilization}->{$cooked_ifDuplex}";	}
  if (defined($ifCstmOids->{thresholds}->{ifAccuracy}->{setting}))		{ $threshold_ifError         = "$ifCstmOids->{thresholds}->{ifAccuracy}->{setting}";	}


} # loadMonitorThresholds


sub snmpGet($$) {

  my $management_ip   = $_[0];
  my $snmp_community  = $_[1];
  my $snmp_username   = $_[2];
  my $snmp_password   = $_[3];
  my $snmp_version    = $_[4];


   my ($session, $error) = Net::SNMP->session(
      -hostname  => shift || $management_ip,
      -community => shift || $snmp_community,
      -version   => shift || $snmp_version,
      -port      => shift || 161
   );

   if (!defined($session)) {
      printf("snmpGet ERROR: %s.\n", $error);
      exit 1;
   }

   my $result = $session->get_request(
      -varbindlist => [@snmp_oid]
   );

   if (!defined($result)) {
      printf("snmpGet result ERROR: %s.\n", $session->error);
      $session->close;
      exit 1;
   }

      $session->close;
      return $result;

} # snmpGet


sub loadInterfaceConfig($$) {


  #
  # Check to see if there is a configuration file specific to this inteface, if there is use it.
  # Otherwise this must be the first time the script has been run for this interface, use the global and device templates.

  if (open (my $dfh, "<", $config_specific_template)) {

	close($dfh);

	$ifStdOids  = XMLin($config_specific_template);

	if (defined($ifStdOids->{fields}->{ifSpeed}->{oid}))		{ $ifSpeed	   = "$ifStdOids->{fields}->{ifSpeed}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifInOctets}->{oid}))		{ $ifInOctets	   = "$ifStdOids->{fields}->{ifInOctets}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifOutOctets}->{oid}))	{ $ifOutOctets	   = "$ifStdOids->{fields}->{ifOutOctets}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifInUcastPkts}->{oid}))	{ $ifInUcastPkts   = "$ifStdOids->{fields}->{ifInUcastPkts}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifOutUcastPkts}->{oid}))	{ $ifOutUcastPkts  = "$ifStdOids->{fields}->{ifOutUcastPkts}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifInNUcastPkts}->{oid}))	{ $ifInNUcastPkts  = "$ifStdOids->{fields}->{ifInNUcastPkts}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifOutNUcastPkts}->{oid}))	{ $ifOutNUcastPkts = "$ifStdOids->{fields}->{ifOutNUcastPkts}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifInErrors}->{oid}))		{ $ifInErrors	   = "$ifStdOids->{fields}->{ifInErrors}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifOutErrors}->{oid}))	{ $ifOutErrors	   = "$ifStdOids->{fields}->{ifOutErrors}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifDescr}->{oid}))		{ $ifDescr	   = "$ifStdOids->{fields}->{ifDescr}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifName}->{oid}))		{ $ifName	   = "$ifStdOids->{fields}->{ifName}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifAlias}->{oid}))		{ $ifAlias	   = "$ifStdOids->{fields}->{ifAlias}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifDuplex}->{oid}))		{ $ifDuplex	   = "$ifStdOids->{fields}->{ifDuplex}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifDuplexDesc}->{value}))	{ $ifDuplexDesc	   = "$ifStdOids->{fields}->{ifDuplexDesc}->{value}";	}
	if (defined($ifStdOids->{fields}->{ifSCollisions}->{oid}))	{ $ifSCollisions   = "$ifStdOids->{fields}->{ifSCollisions}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifMCollisions}->{oid}))	{ $ifMCollisions   = "$ifStdOids->{fields}->{ifMCollisions}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifType}->{oid}))		{ $ifType	   = "$ifStdOids->{fields}->{ifType}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifHwAddr}->{oid}))		{ $ifHwAddr	   = "$ifStdOids->{fields}->{ifHwAddr}->{oid}";		}
	if (defined($ifStdOids->{fields}->{ifInDiscards}->{oid}))	{ $ifInDiscards	   = "$ifStdOids->{fields}->{ifInDiscards}->{oid}";	}
	if (defined($ifStdOids->{fields}->{ifInDiscards}->{oid}))	{ $ifOutDiscards   = "$ifStdOids->{fields}->{ifOutDiscards}->{oid}";	}


  #
  # Load the values from the last run

	if (defined($ifStdOids->{fields}->{ifSpeed}->{value}))		{ $difSpeed	    = "$ifStdOids->{fields}->{ifSpeed}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifInOctets}->{value}))	{ $difInOctets	    = "$ifStdOids->{fields}->{ifInOctets}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifOutOctets}->{value}))	{ $difOutOctets	    = "$ifStdOids->{fields}->{ifOutOctets}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifInUcastPkts}->{value}))	{ $difInUcastPkts   = "$ifStdOids->{fields}->{ifInUcastPkts}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifOutUcastPkts}->{value}))	{ $difOutUcastPkts  = "$ifStdOids->{fields}->{ifOutUcastPkts}->{value}";	}
	if (defined($ifStdOids->{fields}->{ifInNUcastPkts}->{value}))	{ $difInNUcastPkts  = "$ifStdOids->{fields}->{ifInNUcastPkts}->{value}";	}
	if (defined($ifStdOids->{fields}->{ifOutNUcastPkts}->{value}))	{ $difOutNUcastPkts = "$ifStdOids->{fields}->{ifOutNUcastPkts}->{value}";	}
	if (defined($ifStdOids->{fields}->{ifInErrors}->{value}))	{ $difInErrors	    = "$ifStdOids->{fields}->{ifInErrors}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifOutErrors}->{value}))	{ $difOutErrors	    = "$ifStdOids->{fields}->{ifOutErrors}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifDuplex}->{value}))		{ $difDuplex	    = "$ifStdOids->{fields}->{ifDuplex}->{value}";		}
	if (defined($ifStdOids->{fields}->{ifSCollisions}->{value}))	{ $difSCollisions   = "$ifStdOids->{fields}->{ifSCollisions}->{value}";		}	
	if (defined($ifStdOids->{fields}->{ifMCollisions}->{value}))	{ $difMCollisions   = "$ifStdOids->{fields}->{ifMCollisions}->{value}";		}
	if (defined($ifStdOids->{fields}->{lastUpdate}->{value}))	{ $dlastUpdate      = "$ifStdOids->{fields}->{lastUpdate}->{value}";		}


  #
  # Load the threshold serrings for this interface

	$threshold_ifUtilization = "$ifStdOids->{thresholds}->{ifUtilization}->{setting}";
	$threshold_ifError       = "$ifStdOids->{thresholds}->{ifAccuracy}->{setting}";

  } else { return 0; }


  return 1;


} # loadInterfaceConfig


sub outputDebugInfo {

  	#
	# Initialize function

	print "query  -> $dbquery \n";
	print "result -> $cdbr \n";
	print "global template -> $config_template \n";
	print "device template -> $config_custom_template \n";   
	print "interface template -> $config_specific_template \n";
	      
	#
	# Inthealth Meain

	printf ("%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n%s \n",

		   $ifInOctets,
		   $ifOutOctets,
		   $ifInUcastPkts,
		   $ifOutUcastPkts,
		   $ifInNUcastPkts,
		   $ifOutNUcastPkts,
		   $ifInErrors,
		   $ifOutErrors,
		   $ifSpeed,
		   $ifDescr,		   
		   $ifName,
		   $ifAlias,
		   $ifDuplex,
		   $ifDuplexDesc,
		   $ifSCollisions,
		   $ifMCollisions,
		   $ifType,
		   $ifHwAddr,
		   $ifInDiscards,
		   $ifOutDiscards
		  );

	#
	# cookInterfaceHealth

	printf ("difSpeed=%s \ndifInOctets=%s \ndifOutOctets=%s \ndifInUcastPkts=%s \ndifOutUcastPkts=%s \ndifInNUcastPkts=%s \ndifOutNUcastPkts=%s \ndifInErrors=%s \ndifOutErrors=%s \ndifDuplex=%s \ndifSCollisions=%s \ndifMCollisions=%s \ndlastUpdate=%s \n",

		   $difSpeed,
		   $difInOctets,
		   $difOutOctets,
		   $difInUcastPkts,
		   $difOutUcastPkts,
		   $difInNUcastPkts,
		   $difOutNUcastPkts,
		   $difInErrors,
		   $difOutErrors,
		   $difDuplex,
		   $difSCollisions,
		   $difMCollisions,
		   $dlastUpdate
		  );
	#
	# Monitor Thresholds

	print "ifUtil threshold set to $threshold_ifUtilization \n";
	print "ifError threshold set to $threshold_ifError \n "; 

} # outputDebugInfo


sub outputToXMLFile($$) {

  #
  # update xml file with delta and display values.

  open ($dfh, ">", $config_specific_template);

print {$dfh} <<"END";
<interface>
	<name>Interface Health</name>
	<description>Measures the health of an ethernet interface</description>
	
	<fields>
		<ifScript>
			<name>Script used to generate this file</name>
			<oid>$0 @ARGV[0] @ARGV[1] @ARGV[2] @ARGV[3] @ARGV[4]</oid>
			<value>$script_name[((scalar(@script_name)) - 1)]</value>
		</ifScript>
		<ifName>
			<name>Name (IF-MIB)</name>
			<oid>$ifName</oid>
			<value>$snmpResult->{$ifName}</value>
		</ifName>
		<ifDescr>
			<name>Description</name>
			<oid>$ifDescr</oid>
			<value>$snmpResult->{$ifDescr}</value>
		</ifDescr>
		<ifAlias>
			<name>Alias (IF-MIB)</name>
			<oid>$ifAlias</oid>
			<value>$snmpResult->{$ifAlias}</value>
		</ifAlias>
		<ifSpeed>
			<name>Speed</name>
			<oid>$ifSpeed</oid>
			<value>$snmpResult->{$ifSpeed}</value>
		</ifSpeed>
		<ifDuplex>
			<name>Interface Duplex</name>
			<oid>$ifDuplex</oid>
			<value>$snmpResult->{$ifDuplex}</value>
		</ifDuplex>
		<ifDuplexDesc>
			<name>Interface Duplex Description</name>
			<oid>$ifDuplex</oid>
			<value>$cooked_ifDuplex</value>
		</ifDuplexDesc>
		<ifSCollisions>
			<name>Single Collision Frames</name>
			<oid>$ifSCollisions</oid>
			<value>$snmpResult->{$ifSCollisions}</value>
		</ifSCollisions>
		<ifMCollisions>
			<name>Multiple Collision Frames</name>
			<oid>$ifMCollisions</oid>
			<value>$snmpResult->{$ifMCollisions}</value>
		</ifMCollisions>
		<ifType>
			<name>Type</name>
			<oid>$ifType</oid>
			<value>$snmpResult->{$ifType}</value>
		</ifType>
		<ifHwAddr>
			<name>Hardware Address</name>
			<oid>$ifHwAddr</oid>
			<value>$snmpResult->{$ifHwAddr}</value>
		</ifHwAddr>
		<ifInOctets>
			<name>Bytes In</name>
			<oid>$ifInOctets</oid>
			<value>$snmpResult->{$ifInOctets}</value>
		</ifInOctets>
		<ifOutOctets>
			<name>Bytes Out</name>
			<oid>$ifOutOctets</oid>
			<value>$snmpResult->{$ifOutOctets}</value>
		</ifOutOctets>
		<ifInDiscards>
			<name>Discarded Packets In</name>
			<oid>$ifInDiscards</oid>
			<value>$snmpResult->{$ifInDiscards}</value>
		</ifInDiscards>
		<ifOutDiscards>
			<name>Discarded Packets Out</name>
			<oid>$ifOutDiscards</oid>
			<value>$snmpResult->{$ifOutDiscards}</value>
		</ifOutDiscards>
		<ifInNUcastPkts>
			<name>Non-Unicast Packets In</name>
			<oid>$ifInNUcastPkts</oid>
			<value>$snmpResult->{$ifInNUcastPkts}</value>
		</ifInNUcastPkts>
		<ifOutNUcastPkts>
			<name>Non-Unicast Packets Out</name>
			<oid>$ifOutNUcastPkts</oid>
			<value>$snmpResult->{$ifOutNUcastPkts}</value>
		</ifOutNUcastPkts>
		<ifInUcastPkts>
			<name>Unicast Packets In</name>
			<oid>$ifInUcastPkts</oid>
			<value>$snmpResult->{$ifInUcastPkts}</value>
		</ifInUcastPkts>
		<ifOutUcastPkts>
			<name>Unicast Packets Out</name>
			<oid>$ifOutUcastPkts</oid>
			<value>$snmpResult->{$ifOutUcastPkts}</value>
		</ifOutUcastPkts>
		<ifInErrors>
			<name>Errors In</name>
			<oid>$ifInErrors</oid>
			<value>$snmpResult->{$ifInErrors}</value>
		</ifInErrors>
		<ifOutErrors>
			<name>Errors Out</name>
			<oid>$ifOutErrors</oid>
			<value>$snmpResult->{$ifOutErrors}</value>
		</ifOutErrors>
		<lastUpdate>
			<name>Last Update Time</name>
			<oid> </oid>
			<value>$lastUpdate</value>
		</lastUpdate>
	</fields>

	<thresholds>
		<ifUtilization>
			<setting>$threshold_ifUtilization</setting>
		</ifUtilization>
		<ifAccuracy>
			<setting>$threshold_ifError</setting>
		</ifAccuracy>
	</thresholds>
</interface>

END

close ($dfh);

} # outputToXMLFile


sub outputEventTicket($$) {

  #
  # update the event ticket file with display values.

  open ($dfh, ">", $event_ticket);

print {$dfh} <<"END";
<aloexml>

	<name>Interface Health</name>
	<description>Measures the health of an ethernet interface</description>
	<refreshvalue>$0 @ARGV[0] @ARGV[1] @ARGV[2] @ARGV[3] @ARGV[4]</refreshvalue>

	<ticketfields>
		<tnumber>
			<desc>Ticket Number</desc>
			<value>$ticket_number</value>
		</tnumber>
		<tstatus>
			<desc>Ticket Status</desc>
			<value>$ticket_status</value>
		</tstatus>
	</ticketfields>

	<displayfields>
		<dtitle>
			<colHeader>$snmpResult->{$ifDescr} ($snmpResult->{$ifAlias})</colHeader>
		</dtitle>
		<difSpeed>
			<heading>Speed</heading>
			<value>$cooked_ifSpeed</value>
		</difSpeed>
		<difDuplex>
			<heading>Duplex</heading>
			<value>$cooked_ifDuplex</value>
		</difDuplex>
		<difInOctets>
			<heading>Bytes In</heading>
			<value>$cooked_ifInOctets</value>
		</difInOctets>
		<difOutOctets>
			<heading>Bytes Out</heading>
			<value>$cooked_ifOutOctets</value>
		</difOutOctets>
		<difTotalOctets>
			<heading>Bytes Transferred</heading>
			<value>$cooked_ifTotalOctets</value>
		</difTotalOctets>
		<difTotalPkts>
			<heading>Packets Transferred</heading>
			<value>$cooked_ifTotalPackets</value>
		</difTotalPkts>
		<difTotalCollisions>
			<heading>Collisions</heading>
			<value>$cooked_ifTotalCollisions</value>
		</difTotalCollisions>
		<difErrors>
			<heading>Errors</heading>
			<value>$cooked_ifErrors</value>
		</difErrors>
		<difAccuracy>
			<heading>Accuracy</heading>
			<value>
				<accuracy>$cooked_ifAccuracy
					<bgcolor>$cooked_ifAccuracyHealth</bgcolor>
				</accuracy>
			</value>
		</difAccuracy>
		<difUtilization>
			<heading>Utilization</heading>
			<value>
				<in>In $cooked_ifInUtilization
					<bgcolor>$cooked_ifInUtilizationHealth</bgcolor></in>
				<out>Out $cooked_ifOutUtilization
					<bgcolor>$cooked_ifOutUtilizationHealth</bgcolor></out>
			</value>
		</difUtilization>
		<dlastUpdate>
			<heading>Refreshed</heading>
			<value>$cooked_lastUpdate</value>
		</dlastUpdate>
	</displayfields>

</aloexml>

END

close ($dfh);

} # outputEventTicket


sub outputToGraphXMLFile($$) {

  #
  # update the graph xml file with display values.

  open ($dfh, ">", $graph_xml_file);

print {$dfh} <<"END";
<aloexml>

	<name>Interface Health</name>
	<description>Measures the health of an ethernet interface</description>
	<refreshvalue>$0 @ARGV[0] @ARGV[1] @ARGV[2] @ARGV[3] @ARGV[4]</refreshvalue>

	<displayfields>
		<dtitle>
			<colHeader>$snmpResult->{$ifDescr} ($snmpResult->{$ifAlias})</colHeader>
		</dtitle>
		<difSpeed>
			<heading>Speed</heading>
			<value>$cooked_ifSpeed</value>
		</difSpeed>
		<difDuplex>
			<heading>Duplex</heading>
			<value>$cooked_ifDuplex</value>
		</difDuplex>
		<difInOctets>
			<heading>Bytes In</heading>
			<value>$cooked_ifInOctets</value>
		</difInOctets>
		<difOutOctets>
			<heading>Bytes Out</heading>
			<value>$cooked_ifOutOctets</value>
		</difOutOctets>
		<difTotalOctets>
			<heading>Bytes Transferred</heading>
			<value>$cooked_ifTotalOctets</value>
		</difTotalOctets>
		<difTotalPkts>
			<heading>Packets Transferred</heading>
			<value>$cooked_ifTotalPackets</value>
		</difTotalPkts>
		<difTotalCollisions>
			<heading>Collisions</heading>
			<value>$cooked_ifTotalCollisions</value>
		</difTotalCollisions>
		<difErrors>
			<heading>Errors</heading>
			<value>$cooked_ifErrors</value>
		</difErrors>
		<difAccuracy>
			<heading>Accuracy</heading>
			<value>
				<accuracy>$cooked_ifAccuracy
					<bgcolor>$cooked_ifAccuracyHealth</bgcolor>
				</accuracy>
			</value>
		</difAccuracy>
		<difUtilization>
			<heading>Utilization</heading>
			<value>
				<in>In $cooked_ifInUtilization
					<bgcolor>$cooked_ifInUtilizationHealth</bgcolor></in>
				<out>Out $cooked_ifOutUtilization
					<bgcolor>$cooked_ifOutUtilizationHealth</bgcolor></out>
			</value>
		</difUtilization>
		<dlastUpdate>
			<heading>Refreshed</heading>
			<value>$cooked_lastUpdate</value>
		</dlastUpdate>
	</displayfields>

</aloexml>

END

close ($dfh);

} # outputToGraphXMLFile


 sub indexQuery($$) {

  my $oid = $ifStdOids->{fields}->{ifIndex}->{oid};

  push (@snmp_oid,$oid);

  my $management_ip   = $_[0];
  my $snmp_community  = $_[1];
  my $snmp_username   = $_[2];
  my $snmp_password   = $_[3];
  my $snmp_version    = $_[4];

   my ($session, $error) = Net::SNMP->session(
      -hostname  => shift || $management_ip,
      -community => shift || $snmp_community,
      -version   => shift || $snmp_version,
      -port      => shift || 161
   );

   if (!defined($session)) {
      printf("snmpindexQuery ERROR: %s.\n", $error);
      exit 1;
   }

   my $result = $session->get_table(
      -baseoid => $oid
   );

   if (!defined($result)) {
      printf("snmpindexQuery result ERROR: %s.\n", $session->error);
      $session->close;
      exit 1;
   }

      $session->close;

	foreach my $item (oid_lex_sort(keys(%{$result}))) { print "$result->{$item} \n"; }

  } # indexQuery


 sub queryQuery($$) {

  my $management_ip   = $_[0];
  my $snmp_community  = $_[1];
  my $snmp_username   = $_[2];
  my $snmp_password   = $_[3];
  my $snmp_version    = $_[4];
  my $index_value     = $_[5];

  my $i = 0;
  my $oid = $ifStdOids->{fields}->{ifIndex}->{oid};
  my $indexoid = $ifStdOids->{fields}->{ifIndex}->{oid};

  my @oidindexes =();
  my @oidvalues  =();

  if ($index_value eq "ifName")  { $oid = $ifStdOids->{fields}->{ifName}->{oid}; }
  if ($index_value eq "ifAlias") { $oid = $ifStdOids->{fields}->{ifAlias}->{oid}; }
  if ($index_value eq "ifDescr") { $oid = $ifStdOids->{fields}->{ifDescr}->{oid}; }

   my ($session, $error) = Net::SNMP->session(
      -hostname  => shift || $management_ip,
      -community => shift || $snmp_community,
      -version   => shift || $snmp_version,
      -port      => shift || 161
   );

   if (!defined($session)) {
      printf("snmpqueryQuery ERROR: %s.\n", $error);
      exit 1;
   }

   my $indexresult = $session->get_table(
      -baseoid => $indexoid
   );

   if (!defined($indexresult)) {
      printf("snmpqueryQuery result ERROR: %s.\n", $session->error);
      $session->close;
      exit 1;
   }

   my $result = $session->get_table(
      -baseoid => $oid
   );

   if (!defined($result)) {
      printf("snmpqueryQuery result ERROR: %s.\n", $session->error);
      $session->close;
      exit 1;
   }

      $session->close;

	foreach my $item (oid_lex_sort(keys(%{$result}))) { push (@oidvalue, $result->{$item}); }
	foreach my $indexitem (oid_lex_sort(keys(%{$indexresult}))) { push (@oidindex, $indexresult->{$indexitem}); }

	my $sizeof_oidindex = @oidindex;

	while ($i < $sizeof_oidindex) { 

		print "$oidindex[$i] $oidvalue[$i]\n";
		$i++;
	}

  } # queryQuery