#!/usr/local/bin/perl
##################################################################
# @(#) $Id: mrtg-ping-probe,v 2.3 2001/01/21 20:01:16 pwo Exp $
# @(#) mrtg-ping-probe release $Name: Release_2_0_2 $
#
# Copyright (c) 1997-2001 Peter W. Osel <pwo@guug.de>.
# All Rights Reserved.
#
# See the file COPYRIGHT in the distribution for the exact terms.
#
##################################################################
#
# "I saw -- from the cathedral -- you were watching me"
#
#	-- Tanita Tikaram, `Cathedral Song'
#	on: Tanita Tikaram, `Ancient Heart', 1988, WEA Records
#
##################################################################
#
# Modified from the original for use by cacti
# Any questions or comments regarding this code should be directed to:              
#  - sidewinder at shitworks.com
#
##################################################################

use Config;
use File::Basename;
use XML::Simple;
use Mysql;


 require "c:/inetpub/wwwroot/cacti/aloe/include/aloeScriptFunctions.pl";
# require "c:/dev/aloe/include/aloeScriptFunctions.pl";

  $aloe_config_file = 'c:/inetpub/wwwroot/cacti/aloe/config/aloe-config.xml';
#  $aloe_config_file = 'c:/dev/aloe/config/aloe-config.xml';

  #
  # Load the configuration settings from aloe.xml.

  if (open (my $afh, "<", $aloe_config_file)) {

  	close($afh);
	$aloe  = XMLin($aloe_config_file);

  } else { die "Could not find $aloe_config_file, script can not continue"; }


  my $debug		= $aloe->{settings}->{debug}->{value};

  our $cactidbhost	= $aloe->{settings}->{cactiDBHost}->{value};
  our $cactidb		= $aloe->{settings}->{cactiDB}->{value};
  our $cactidbuser	= $aloe->{settings}->{cactiDBUser}->{value};
  our $cactidbpswd	= $aloe->{settings}->{cactiDBPswd}->{value};

  our $config_path      = $aloe->{settings}->{configPath}->{value};

  my $script_name	= basename($0);
  my $event_source      = "cacti -> $script_name";

  our $event_ticket	= '';
  our $ticket_status    = '';
  our $ticket_number    = '';



  ($HostToPing) = @ARGV[0];
  ($index)	= @ARGV[1];
  ($qvalue)	= @ARGV[2];


	if ($index eq "index") { indexQuery(); exit 0; }

	if ($index eq "query") { queryQuery(qvalue); exit 0; }




  my $cdbh = Mysql->connect(undef, $cactidb, $cactidbuser, $cactidbpswd);
  my $cdbh = Mysql->connect($cactidbhost, $cactidb, $cactidbuser, $cactidbpswd);

  #
  # find the rrd file associated with this script instance

  my $dbquery = join('',"select rrd_path from data_input_data_cache where command like '%$script_name", " ", $HostToPing, "%';");

  my $csth = $cdbh->query($dbquery);
  my $cdbr = $csth->fetchrow();

  if ($debug) {  print "query  -> $dbquery \n"; print "result -> $cdbr \n"; }

  our $config_template          = join('', $config_path, "ping-probe-config-template.xml");
  our $config_specific_template = join('', $config_path, @ARGV[0], "/ping-probe-config-template.xml" );
  our $graph_xml_file           = join('', $cdbr, ".xml" );

  if ($debug) {  print "ping-probe output file -> $config_specific_template \n"; }


  #
  # Try to load configuration parameters from the xml file specific for this script instance
  # If that doesn't work, assume it is the first time the script has run for this script instance and generate one.


  if (!loadConfigSpecificTemplate()) {

	if ($debug) { print "loading default values\n"; }

	loadConfigTemplate();
	outputToXMLFile();
	loadConfigSpecificTemplate();
  }


  #
  # Check Sanity of Arguments

  $err += check_numeric("-d", $DeadTime);
  $err += check_numeric("-k", $PacketCount);
  $err += check_numeric("-l", $PacketLength);
  $err += check_numeric("-t", $TimeOut);
  $err += check_picklst("-p", $PickList);

  #
  # Ping the Host

  ($pt{min}, $pt{avg}, $pt{max}, $pt{loss}) =
  	ping($HostToPing, $PacketLength, $PacketCount, $TimeOut);

  my  $lastUpdate = time();
  my  $cooked_lastUpdate = localtime($lastUpdate);

  print "$Prog_name: DBG: main(): ping() ret: $pt{min}, $pt{avg}, $pt{max}, $pt{loss}\n" if $debug;

  $PickList =~ /^(?:(\d+)\*)?(\w+)\/(?:(\d+)\*)?(\w+)$/;
  ($f1, $p1, $f2, $p2) = ($1, $2, $3, $4);
  $f1 = $f1 ? $f1 : 1;
  $f2 = $f2 ? $f2 : 1;

  print "$Prog_name: DBG: main(): before psub: f = ($f1 $f2); p = ($p1 $p2)\n" if $debug;

  $p1 = $p1 =~ /^\d+$/ ? $p1 : $pt{$p1};
  $p2 = $p2 =~ /^\d+$/ ? $p2 : $pt{$p2};

  print "$Prog_name: DBG: main(): after  psub: f = ($f1 $f2); p = ($p1 $p2)\n" if $debug;


  $pAvg  = $f1 * $p1;
  $pLoss = $f2 * $p2;

  our $cooked_avg_bg  = "Good";
  our $cooked_loss_bg = "Good";
  my $threshold_violation = 0;

  if (($pAvg > $rtt_warn_threshold) && ($pAvg <= $rtt_error_threshold)) {
		 $cooked_avg_bg = "warning";
		 push (@threshold_vals,$cooked_avg_bg);
		 $evt_message   = "Average RTT now at $pAvg ms";
		 $threshold_violation = 1;

		  ($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $HostToPing, undef, $0, \@threshold_vals, $evt_message,  $cooked_avg_bg);

		  logEvent($aloe, $HostToPing, $0, $ticket_status, $evt_message, $cooked_avg_bg);

		 outputEventTicket();

  }

  	elsif ($pAvg > $rtt_error_threshold) { 
		 $cooked_avg_bg = "err";
		 push (@threshold_vals,$cooked_avg_bg);
		 $evt_message   = "Average RTT now at $pAvg ms";
		 $threshold_violation = 1;

		  ($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $HostToPing, undef, $0, \@threshold_vals, $evt_message,  $cooked_avg_bg);

		  logEvent($aloe, $HostToPing, $0, $ticket_status, $evt_message, $cooked_avg_bg);

		 outputEventTicket();
	}


  if (($pLoss > $pktLoss_warn_threshold) && ($pLoss <= $pktLoss_error_threshold)) { 
		 $cooked_loss_bg = "warning";
		 push (@threshold_vals,$cooked_loss_bg);
		 $evt_message = "Packet Loss now at $pLoss%";
		 $threshold_violation = 1;


		  ($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $HostToPing, undef, $0, \@threshold_vals, $evt_message,  $cooked_loss_bg);

		  logEvent($aloe, $HostToPing, $0, $ticket_status, $evt_message, $cooked_loss_bg);

		 outputEventTicket();
  }

	elsif ($pLoss > $pktLoss_error_threshold) { 
		 $cooked_loss_bg = "err";
		 push (@threshold_vals,$cooked_loss_bg);
		 $evt_message = "Packet Loss now at $pLoss%";
		 $threshold_violation = 1;


		  ($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $HostToPing, undef, $0, \@threshold_vals, $evt_message,  $cooked_loss_bg);

		  logEvent($aloe, $HostToPing, $0, $ticket_status, $evt_message, $cooked_loss_bg);

		 outputEventTicket();

	}

	if (($aloe->{settings}->{aloeTicketMethod}->{value}) && (!$threshold_violation)) {
		 push (@threshold_vals,$cooked_avg_bg);
		 push (@threshold_vals,$cooked_loss_bg);
		 
		 my $event_priority = "notice";

		  ($event_ticket, $ticket_number, $ticket_status) = processEvent($aloe, $HostToPing, undef, $0, \@threshold_vals, $log_message, $event_priority);

			if ($ticket_status eq "Close") {
				 $evt_message = "Monitored values back within threshold, closing ticket # $ticket_number.";
				 logEvent($aloe, $HostToPing, $0, $ticket_status, $evt_message, $event_priority);
			}

	}

  #
  # Output values to cacti

  printf "rtt_avg:%d pkt_loss:%d", $f1 * $p1, $f2 * $p2;

  #
  # Output values to xml files

    outputToXMLFile();
    outputToGraphXMLFile();



exit(0);


##################################################################
sub check_numeric {
	my($opt, $val) = @_;
	my($err) = 0;

	unless ($val =~ /^\d+$/) {
		print STDERR "$Prog_name: FATAL: option $opt requires numeric argument.\n";
		++$err;
		}
	return($err);
	}

##################################################################
sub check_picklst {
	my($opt, $val) = @_;
	my($err, $i) = (0, 0);
	my(@v, @n);

	unless ($val =~ /^(?:(\d+)\*)?(\w+)\/(?:(\d+)\*)?(\w+)$/) {
		print STDERR "$Prog_name: FATAL: option $opt requires [factor*]word/[factor*]word argument, I found \"$val\"\n";
		++$err;
		}
	@n = ($1, $3);
	@v = ($2, $4);

	print "$Prog_name: DBG: check_picklst(): n = (@n); v = (@v)\n" if $debug;

	foreach $i (0..1) {
		unless ($v[$i] =~ /^(min|max|avg|loss|\d+)$/) {
			print STDERR "$Prog_name: FATAL: option $opt uses unknown item $v[$i]\n";
			print STDERR "$Prog_name: FATAL: option $opt may choose from min|max|avg|loss or number\n";
			++$err;
			}
		}

	return($err);
	}

##################################################################
# ping selects the external or internal, builtin ping method
# and starts the external ping program optionally with a
# timout to abort external ping programs that seem to hang
# when the target is unreachable.

sub ping {
	my($host, $length, $count, $timeout) = @_;
	my(%pt);

	($pt{min}, $pt{avg}, $pt{max}, $pt{loss}) =
		ext_ping($host, $length, $count, $timeout);

	return($pt{min}, $pt{avg}, $pt{max}, $pt{loss});
	}

##################################################################
# ping host retrieve and return min, avg, max round trip time
# relying on finding a standard ping in PATH.
# Try to not be platform specific if at all possible.
#
sub ext_ping {
	my($host, $length, $count, $timeout) = @_;
	my(%ping, $ping_output, $redirect_stderr, $pid, %pt);
	my($alarm_exists);


	# List of known ping programs
	%ping = (
		'MSWin32' =>	"ping -l $length -n $count $host",
		'aix'	=>	"/etc/ping $host $length $count",
		'bsdos'	=>	"/bin/ping -s $length -c $count $host",
		'freebsd' =>	"/sbin/ping -s $length -c $count $host",
		'hpux'	=>	"/etc/ping $host $length $count",
		'irix'	=>	"/usr/etc/ping -c $count -s $length $host",
		'linux'	=>	"/bin/ping -c $count -s $length $host",
		'netbsd' =>	"/sbin/ping -s $length -c $count $host",
		'openbsd' =>	"/sbin/ping -s $length -c $count $host",
		'os2' =>	"ping $host $length $count",
		'OS/2' =>	"ping $host $length $count",
		'dec_osf'=>	"/sbin/ping -s $length -c $count $host",
		'solaris' =>	"/usr/sbin/ping -s $host $length $count",
		'sunos'	=>	"/usr/etc/ping -s $host $length $count",
		);

	unless (defined($ping{$Config{'osname'}})) {
		print STDERR "${Prog_name}: FATAL: Not yet configured for $Config{'osname'}\n";
		exit(1);
		}

	# add ping options, if any
	$ping{$Config{'osname'}} =~ s/ / $PingOptions / if $PingOptions;

	# windows 95/98 does not support stderr redirection...
	# also OS/2 users reported problems with stderr redirection...
	$redirect_stderr = $Config{'osname'} =~ /^(MSWin32|os2|OS\/2)$/i ? "" : "2>&1";

	# initialize return values
	$pt{loss} = 100;
	$pt{min} = $pt{avg} = $pt{max} = $DeadTime;

	unless ($pid = open(PING, "$ping{$Config{'osname'}} $redirect_stderr |")) {
		print STDERR "${Prog_name}: FATAL: Can't open $ping{$Config{'osname'}}: $!";
		exit(1);
		}

	$alarm_exists =  eval { alarm(0); 1 };
	print STDERR "${Prog_name}: WARN: builtin alarm() does not exist, can't timout ping command\n"
		if $Verbose && $timeout && !$alarm_exists;

	if ($alarm_exists) {
		# read and timeout ping() if it takes too long...
		eval {
			local $SIG{ALRM} = sub { die "alarm\n" };	# \n required!
			alarm $timeout;
			while (<PING>) {
				$ping_output .= $_;
				}
			alarm 0;
			};

		if ($@) {
			die unless $@ eq "alarm\n";	# propagate unexpected errors
			# timed out, kill child, get remaining output, ...
			kill $pid;
			while (<PING>) {
				$ping_output .= $_;
				}
			close(PING);

			# ... and set return values to dead values
			unless ($Silent) {
				print STDERR "${Prog_name}: ERROR: external ping hit timeout $timeout, assuming target $host is unreachable\n";
				print STDERR "${Prog_name}: INFO: The output of the ping command $ping{$Config{'osname'}} was:\n";
				print STDERR "$ping_output\n";
				}
			return($pt{min}, $pt{avg}, $pt{max}, $pt{loss});
			}
		}
	else {
		# read and hope that ping() will return in time...
		while (<PING>) {
			$ping_output .= $_;
			}

		}

	# didn't time out, analyse ping output.
	close(PING);

	# try to find round trip times
	if ($ping_output =~ m@round-trip(?:\s+\(ms\))?\s+min/avg/max(?:/(?:m|std)-?dev)?\s+=\s+(\d+(?:\.\d+)?)/(\d+(?:\.\d+)?)/(\d+(?:\.\d+)?)@m) {
		$pt{min} = $1; $pt{avg} = $2; $pt{max} = $3;
		}

	elsif ($ping_output =~ m@rtt(?:\s+\(ms\))?\s+min/avg/max(?:/(?:m|std)-?dev)?\s+=\s+(\d+(?:\.\d+)?)/(\d+(?:\.\d+)?)/(\d+(?:\.\d+)?)@m) {
		$pt{min} = $1; $pt{avg} = $2; $pt{max} = $3;
		}

	elsif ($ping_output =~ m@^\s+\w+\s+=\s+(\d+(?:\.\d+)?)ms,\s+\w+\s+=\s+(\d+(?:\.\d+)?)ms,\s+\w+\s+=\s+(\d+(?:\.\d+)?)ms\s+$@m) {
		# this should catch most windows locales
		$pt{min} = $1; $pt{avg} = $3; $pt{max} = $2;
		}
	else {
		unless ($Silent) {
			print STDERR "${Prog_name}: ERROR: Could not find ping summary for $host\n";
			print STDERR "${Prog_name}: INFO: The output of the ping command $ping{$Config{'osname'}} was:\n";
			print STDERR "$ping_output\n";
			}
		}

	# try to find packet loss
	# ToDo: only if requested?)
	if ($ping_output =~ m@(\d+)% packet loss$@m) {
		# Unix
		$pt{loss} = $1;
		}

	elsif ($ping_output =~ m@(\d+)% packet|loss,\s+$@m) {
		# Slackware
		$pt{loss} = $1;
		}

	elsif ($ping_output =~ m@\(perte\s+(\d+)%\),\s+$@m) {
		# Windows french locale
		$pt{loss} = $1;
		}
	elsif ($ping_output =~ m@\((\d+)%\s+(?:loss|perdidos)\),\s+$@m) {
		# Windows portugesee, spanish locale
		$pt{loss} = $1;
		}
	else {
		unless ($Silent) {
			print STDERR "${Prog_name}: ERROR: Could not find packet loss summary for $host\n";
			print STDERR "${Prog_name}: INFO: The output of the ping command $ping{$Config{'osname'}} was:\n";
			print STDERR "$ping_output\n";
			}
		}

	return($pt{min}, $pt{avg}, $pt{max}, $pt{loss});
}


sub loadConfigSpecificTemplate($$) {

 #
 # Load the configuration template specific to this host.

  #
  # Check to see if the global template has changed, if it has update the config specifc template.

  if ((stat($config_template))[9] > (stat($config_specific_template))[9]) {

	if ($debug) { print "Global template change detected, loading new values\n"; }

	loadConfigTemplate();
	outputToXMLFile();
	loadConfigSpecificTemplate();

  }

  if (open (my $cfh, "<", $config_specific_template)) {

  	close($cfh);
	$cfgParams  = XMLin($config_specific_template);

	if (defined($cfgParams->{config}->{cDebug}->{value}))		{ $debug	= "$cfgParams->{config}->{cDebug}->{value}";		}
	if (defined($cfgParams->{config}->{cSilent}->{value}))		{ $Silent	= "$cfgParams->{config}->{cSilent}->{value}";		}
	if (defined($cfgParams->{config}->{cDeadTime}->{value}))	{ $DeadTime	= "$cfgParams->{config}->{cDeadTime}->{value}";		}
	if (defined($cfgParams->{config}->{cPacketCount}->{value}))	{ $PacketCount	= "$cfgParams->{config}->{cPacketCount}->{value}";	}
	if (defined($cfgParams->{config}->{cPacketLength}->{value}))	{ $PacketLength	= "$cfgParams->{config}->{cPacketLength}->{value}";	}
	if (defined($cfgParams->{config}->{cPickList}->{value}))	{ $PickList	= "$cfgParams->{config}->{cPickList}->{value}";		}
	if (defined($cfgParams->{config}->{cPingOptions}->{value}))	{ $PingOptions	= "$cfgParams->{config}->{cPingOptions}->{value}";	}
	if (defined($cfgParams->{config}->{cTimeOut}->{value}))		{ $TimeOut	= "$cfgParams->{config}->{cTimeOut}->{value}";		}

	if (defined($cfgParams->{threshold}->{trtt}->{warn}))		{ $rtt_warn_threshold       = "$cfgParams->{threshold}->{trtt}->{warn}";		}
	if (defined($cfgParams->{threshold}->{trtt}->{error}))		{ $rtt_error_threshold      = "$cfgParams->{threshold}->{trtt}->{error}";		}
	if (defined($cfgParams->{threshold}->{tpktLoss}->{warn}))	{ $pktLoss_warn_threshold   = "$cfgParams->{threshold}->{tpktLoss}->{warn}";		}
	if (defined($cfgParams->{threshold}->{tpktLoss}->{error}))	{ $pktLoss_error_threshold  = "$cfgParams->{threshold}->{tpktLoss}->{error}";		}

  }  else { return 0; }

  return 1;


} # loadConfigSpecificTemplate

sub loadConfigTemplate($$) {

 #
 # This must be the first time the script has been run for this host.
 # 1st check to see if there is a directory to store any configuration templates this host may use.
 # if not then create one.
 # 2nd the global config template for this script will be sucked up and returned back to the caller


  my $host_config_dir = join('',$config_path,@ARGV[0]);

  if (!opendir (my $dfh, $host_config_dir)) {

	mkdir $host_config_dir;
	if ($debug) { print "directory $host_config_dir has been created\n" }
  }

  if (open (my $cfh, "<", $config_template)) {

  	close($cfh);
	$cfgParams  = XMLin($config_template);

	if (defined($cfgParams->{config}->{cDebug}->{value}))		{ $debug	= "$cfgParams->{config}->{cDebug}->{value}";		}
	if (defined($cfgParams->{config}->{cSilent}->{value}))		{ $Silent	= "$cfgParams->{config}->{cSilent}->{value}";		}
	if (defined($cfgParams->{config}->{cDeadTime}->{value}))	{ $DeadTime	= "$cfgParams->{config}->{cDeadTime}->{value}";		}
	if (defined($cfgParams->{config}->{cPacketCount}->{value}))	{ $PacketCount	= "$cfgParams->{config}->{cPacketCount}->{value}";	}
	if (defined($cfgParams->{config}->{cPacketLength}->{value}))	{ $PacketLength	= "$cfgParams->{config}->{cPacketLength}->{value}";	}
	if (defined($cfgParams->{config}->{cPickList}->{value}))	{ $PickList	= "$cfgParams->{config}->{cPickList}->{value}";		}
	if (defined($cfgParams->{config}->{cPingOptions}->{value}))	{ $PingOptions	= "$cfgParams->{config}->{cPingOptions}->{value}";	}
	if (defined($cfgParams->{config}->{cTimeOut}->{value}))		{ $TimeOut	= "$cfgParams->{config}->{cTimeOut}->{value}";		}

	if (defined($cfgParams->{threshold}->{trtt}->{warn}))		{ $rtt_warn_threshold       = "$cfgParams->{threshold}->{trtt}->{warn}";		}
	if (defined($cfgParams->{threshold}->{trtt}->{error}))		{ $rtt_error_threshold      = "$cfgParams->{threshold}->{trtt}->{error}";		}
	if (defined($cfgParams->{threshold}->{tpktLoss}->{warn}))	{ $pktLoss_warn_threshold   = "$cfgParams->{threshold}->{tpktLoss}->{warn}";		}
	if (defined($cfgParams->{threshold}->{tpktLoss}->{error}))	{ $pktLoss_error_threshold  = "$cfgParams->{threshold}->{tpktLoss}->{error}";		}

  }   else { die "Could not find $config_template, script can not continue"; }


} # loadConfigTemplate


sub outputToXMLFile($$) {

  #
  # update xml file with delta and display values.

  open ($dfh, ">", $config_specific_template);

print {$dfh} <<"END";
<aloexml>
	<name>Ping Probe</name>
	<description>$script_name Measures the RTT to a host using ping</description>
	<refreshvalue>$0 @ARGV[0]</refreshvalue>

	<config>
		<cDebug>
			<desc>Turn debug on or off (0=Off, 1=On)</desc>
			<value>$debug</value>
		</cDebug>
		<cSilent>
			<desc>Do not generate error messages if there is no response from the ping program or if it ran into the timeout. (0=Off, 1=On)</desc>
			<value>$Silent</value>
		</cSilent>
		<cDeadTime>
			<desc>Specifies the value returned for round trip times in case we assume that the target is down.</desc>
			<value>$DeadTime</value>
		</cDeadTime>
		<cPacketCount>
			<desc>Specifies the number of ping packets to be sent.</desc>
			<value>$PacketCount</value>
		</cPacketCount>
		<cPacketLength>
			<desc>Specifies the size of the ping packets that are sent.</desc>
			<value>$PacketLength</value>
		</cPacketLength>
		<cPingOptions>
			<desc>Specifies any additional options to be sent to the ping program. 0 to send none</desc>
			<value>$PingOptions</value>
		</cPingOptions>
		<cPickList>
			<desc>Specifies the option values that are passed back to cacti.</desc>
			<value>$PickList</value>
		</cPickList>
		<cTimeOut>
			<desc>Abort the external ping program after timeout seconds.</desc>
			<value>$TimeOut</value>
		</cTimeOut>
	</config>

	<threshold>
		<trtt>
			<desc>Specify the threshold value (in ms) for round trip time</desc>
			<warn>$rtt_warn_threshold</warn>
			<error>$rtt_error_threshold</error>
		</trtt>
		<tpktLoss>
			<desc>Specify the threshold value (in %) for packet loss</desc>
			<warn>$pktLoss_warn_threshold</warn>
			<error>$pktLoss_error_threshold</error>
		</tpktLoss>
	</threshold>

</aloexml>

END

close ($dfh);

} # outputToXMLFile

sub outputToGraphXMLFile($$) {

  #
  # update the graph xml file with display values.

  open ($dfh, ">", $graph_xml_file);

print {$dfh} <<"END";
<aloexml>
	<name>Ping Probe</name>
	<description>$script_name Measures the RTT to a host using ping</description>
	<refreshvalue>$0 @ARGV[0]</refreshvalue>
	<displayfields>
		<dtitle>
			<colHeader>$HostToPing</colHeader>
		</dtitle>
		<dMinimum>
			<heading>Minimum RTT</heading>
			<value>$pt{min}</value>
		</dMinimum>
		<dMaximum>
			<heading>Maximum RTT</heading>
			<value>$pt{max}</value>
		</dMaximum>
		<dAvgerage>
			<heading>Avgerage RTT</heading>
			<value>
				<rttavg> $pt{avg}
				<bgcolor>$cooked_avg_bg</bgcolor>
				</rttavg>
			</value>
		</dAvgerage>
		<dpktLoss>
			<heading>% Packet Loss</heading>
			<value>
				<ploss> $pt{loss}
				<bgcolor>$cooked_loss_bg</bgcolor>
				</ploss>
			</value>
		</dpktLoss>
		<dlastUpdate>
			<heading>Refreshed</heading>
			<value>$cooked_lastUpdate</value>
		</dlastUpdate>
	</displayfields>
</aloexml>

END

close ($dfh);

} # outputToGraphXMLFile


sub outputEventTicket($$) {

  #
  # update the event ticket file with display values.

  open ($dfh, ">", $event_ticket);

print {$dfh} <<"END";
<aloexml>
	<name>Ping Probe</name>
	<description>$script_name Measures the RTT to a host using ping</description>
	<refreshvalue>$0 @ARGV[0]</refreshvalue>

	<ticketfields>
		<tnumber>
			<desc>Ticket Number</desc>
			<value>$ticket_number</value>
		</tnumber>
		<tstatus>
			<desc>Ticket Status</desc>
			<value>$ticket_status</value>
		</tstatus>
	</ticketfields>

	<displayfields>
		<dtitle>
			<colHeader>$HostToPing</colHeader>
		</dtitle>
		<dMinimum>
			<heading>Minimum RTT</heading>
			<value>$pt{min}</value>
		</dMinimum>
		<dMaximum>
			<heading>Maximum RTT</heading>
			<value>$pt{max}</value>
		</dMaximum>
		<dAvgerage>
			<heading>Avgerage RTT</heading>
			<value>
				<rttavg> $pt{avg}
				<bgcolor>$cooked_avg_bg</bgcolor>
				</rttavg>
			</value>
		</dAvgerage>
		<dpktLoss>
			<heading>% Packet Loss</heading>
			<value>
				<ploss> $pt{loss}
				<bgcolor>$cooked_loss_bg</bgcolor>
				</ploss>
			</value>
		</dpktLoss>
		<dlastUpdate>
			<heading>Refreshed</heading>
			<value>$cooked_lastUpdate</value>
		</dlastUpdate>
	</displayfields>
</aloexml>

END

close ($dfh);

} # outputEventTicket


  sub indexQuery($$) {

  my $cdbh = Mysql->connect(undef, $cactidb, $cactidbuser, $cactidbpswd);
  my $cdbh = Mysql->connect($cactidbhost, $cactidb, $cactidbuser, $cactidbpswd);

  #
  # find the rrd file associated with this script instance

  my $dbquery = ("select id from host order by id");

  my $csth = $cdbh->query($dbquery);

  while (my $host_id = $csth->fetchrow()) {

	print "$host_id \n"; }

  } # indexQuery


  sub queryQuery($$) {

  	my $queryValue = $qvalue;

  	my $cdbh = Mysql->connect(undef, $cactidb, $cactidbuser, $cactidbpswd);
  	my $cdbh = Mysql->connect($cactidbhost, $cactidb, $cactidbuser, $cactidbpswd);

  	my $dbquery = ("select id, $queryValue from host order by id");

  	my $csth = $cdbh->query($dbquery);

  	while (my ($host_id,$result) = $csth->fetchrow()) {

		print "$host_id!$result \n"; }

  } # indexQuery




__END__

